/***************************************************************************
* Titel        : CDEF.H
*
* Description  : globale Definitionen
*
* Environment  : Anpassung auf MSP430
*
* Responsible  : J. Altenburg
*
* Guidelines   :
*
* Revision List:
  ----------------------------------------------------------------------------
  Date     | Author          | Change
  ----------------------------------------------------------------------------
  13.02.03 |J. Altenburg     | Ersterstellung
  ----------------------------------------------------------------------------
           |                 |
  ----------------------------------------------------------------------------
******************************************************************************/
#ifndef CDEF_H
#define CDEF_H

typedef unsigned char byte;                       /* vorzeichenlose 8-Bit-Zahl */
typedef unsigned int word;                        /* vorzeichenlose 16-Bit-Zahl */
typedef signed char int8;                         /* vorzeichenbehaftete 8-Bit-Zahl */
typedef signed int int16;                         /* vorzeichenbehaftete 16-Bit-Zahl */
typedef byte bool;                                /* True/False Aussage */
typedef unsigned long dword;                      /* Long-Zahl */
typedef signed long int32;

#define True                  1
#define False                 0

#define On                    1
#define Off                   0

/* globale Defines */


/* Makros */

#define mcEnaInt()       asm("eint")              /* INT-Enable */
#define mcDisInt()       asm("dint")              /* INT-Disable */


#endif
