	.module ct05.c
	.area text
	.dbfile C:\projekte\msp430\ct05\ct05.c
	.dbfunc e vClockInit _vClockInit fV
;              w -> R4
	.even
_vClockInit::
	push R4
	.dbline -1
	.dbline 109
; /***************************************************************************
; * Titel        : CT05.C
; *
; * Description  : UEXC for MSP430
; *
; * Environment  : ICC430 V6.05, MSP430F149
; *
; * Responsible  : J. Altenburg
; *
; * Guidelines   :
; *
; * Revision List:
;   --------------------------------------------------------------------------
;   Date     | Author          | Change
;   --------------------------------------------------------------------------
;   12.02.04 |J. Altenburg     | first release
;   --------------------------------------------------------------------------
;            |                 |
;   --------------------------------------------------------------------------
; ****************************************************************************/
; 
; /***************************************************************************
; * HEADER-FILES (Only those that are needed in this file)                   *
; ****************************************************************************/
; /* System-headerfiles */
; #include "cdef.h"                  /* General definitions and types */
; #include "msp430x14x.h"         /* MSP430 definitions */
; #include "msp430def.h"
; 
; /* Own headerfiles */
; 
; 
; /* Foreign headerfiles */
; #include "uexec.h"
; #include "navi.h"
; #include "tele.h"
; #include "smd.h"
; #include "i2c.h"
; 
; /***************************************************************************
; * Defines und Makros
; ****************************************************************************/
; 
; /***************************************************************************
; *    Local Function Prototypes
; ****************************************************************************/
; typedef void (* fLocalFunc)( void );    /* function pointer */
; 
; 
; /***************************************************************************
; *    Global Variables
; ****************************************************************************/
; struct stTimer{
;      word Run  : 1;         /* enable, disable scheduling */
;      word F1   : 1;         /* timer flag */
;      } stTimer;
; 
; word wTaskId0; /*
; * Description : Task-ID #0
; */
; 
; word wTaskId1; /*
; * Description : Task-ID #1
; */
; 
; word wTaskId2; /*
; * Descrition  : Task-ID #2
; */
; 
; word wRegister; /*
; * Description : temporaray CPU help register
; */
; 
; byte abTask0[UEXC_MIN_STACK_SIZE]; /*
; * Description : Memory area for task 0
; */
; 
; byte abTask1[UEXC_MIN_STACK_SIZE + 100]; /*
; * Description : Memory area for task 1
; */
; 
; 
; byte abTask2[UEXC_MIN_STACK_SIZE + 100]; /*
; * Description : Memory area for task 2
; */
; 
; 
; enum {      /* TimerB Modulzuweisung */
;     enTB1 = 2,
;     enTB2 = 4,
;     enTB3 = 6,
;     enTB4 = 8,
;     enTB5 = 10,
;     enTB6 = 12
;     };
; 
; 
; 
; /***************************************************************************
; *    Code Area
; ****************************************************************************/
; 
; /***************************************************************************
; *    Function:      Hardware Initialisation
; *
; *    Author:    Jens Altenburg
; ****************************************************************************/
; /* Oszillator 8MHz Crystal */
; void vClockInit( void ){
	.dbline 111
;     word w;
;     WDTCTL = WDTPW + WDTHOLD;       /* Watchdog disable */
	mov #23168,&0x120
	.dbline 118
; #if 0 /* only for testing purposes */
;     P5DIR |= 0x10;                  /* 8MHz-CLK to pin 48 */
;     P5SEL |= 0x10;
;     P5DIR |= 0x20;                  /* SMCLK to pin 49 */
;     P5SEL |= 0x20;
; #endif
;     BCSCTL1 &= ~XT2OFF;             /* Oszillator on */
	and.b #-129,&0x57
L4:
	.dbline 119
;     do  {                              /* checks if 8MHz - crystal runs */
	.dbline 120
;          IFG1 &= ~OFIFG;
	and.b #-3,&0x2
	.dbline 121
	mov #255,R4
	jmp L10
L7:
	.dbline 121
L8:
	.dbline 121
	sub #1,R4
L10:
	.dbline 121
;          for(w = 0xff; w > 0; w--);
	cmp #0,R4
	jne L7
	.dbline 122
;          }
L5:
	.dbline 123
;     while((IFG1 & OFIFG) != 0);
	bit.b #2,&0x2
	jne L4
	.dbline 124
;     BCSCTL2 = 0x88;
	mov.b #136,&0x58
	.dbline -2
	.dbline 126
; //     BCSCTL2 |= SELM1 + SELS + DIVS0;
;     }
L3:
	pop R4
	.dbline 0 ; func end
	ret
	.dbsym r w 4 i
	.dbend
	.dbfunc e vPortInit _vPortInit fV
	.even
_vPortInit::
	.dbline -1
	.dbline 129
; 
; /* I/O Ports */
; void vPortInit( void ){
	.dbline 130
;     P1OUT   = 0xff;                 /* all output, no interrupt */
	mov.b #255,&0x21
	.dbline 131
;     P1DIR   = 0xFF;                 /* Schrittmotor links */
	mov.b #255,&0x22
	.dbline 132
;     P1IES   = 0x00;
	mov.b #0,&0x24
	.dbline 133
;     P1IE    = 0x00;
	mov.b #0,&0x25
	.dbline 134
;     P1SEL   = 0x00;
	mov.b #0,&0x26
	.dbline 135
;     P2OUT   = 0xff;                 /* all output      */
	mov.b #255,&0x29
	.dbline 136
;     P2DIR   = 0xFF;                 /* Schrittmotor rechts  */
	mov.b #255,&0x2a
	.dbline 137
;     P2IES   = 0x00;                 /* */
	mov.b #0,&0x2c
	.dbline 138
;     P2IE    = 0x00;                 /* */
	mov.b #0,&0x2d
	.dbline 139
;     P2SEL   = 0x00;                 /* */
	mov.b #0,&0x2e
	.dbline 141
; 
;     P3OUT   = 0x00;                 /* UART0, P3.4 output */
	mov.b #0,&0x19
	.dbline 142
;     P3DIR   = 0x10;
	mov.b #16,&0x1a
	.dbline 143
;     P3SEL   = 0x30;
	mov.b #48,&0x1b
	.dbline 145
; 
;     P4OUT   = 0xFE;                 /* CFG - Port */
	mov.b #254,&0x1d
	.dbline 146
;     P4DIR   = 0x7f;
	mov.b #127,&0x1e
	.dbline 147
;     P4SEL   = 0x00;
	mov.b #0,&0x1f
	.dbline 149
; #if 1
;     P5OUT   = 0x00;                 /* not used */
	mov.b #0,&0x31
	.dbline 150
;     P5DIR   = 0xFF;
	mov.b #255,&0x32
	.dbline 151
;     P5SEL   = 0x00;
	mov.b #0,&0x33
	.dbline 153
; #endif
;     P6OUT   = 0x00;                 /* not used */
	mov.b #0,&0x35
	.dbline 154
;     P6DIR   = 0x0c;
	mov.b #12,&0x36
	.dbline 155
;     P6SEL   = 0x03;                 /* A/D-converter, not used */
	mov.b #3,&0x37
	.dbline -2
	.dbline 156
;     }
L11:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e vTimeraInit _vTimeraInit fV
	.even
_vTimeraInit::
	.dbline -1
	.dbline 159
; 
; /* Timer A, triggers Scheduler */
; void vTimeraInit( void ){
	.dbline 160
;     TACTL = TASSEL1 + TACLR;        /* SMCLK, clear TAR */
	mov #516,&0x160
	.dbline 161
;     CCTL0 = CCIE;                   /* CCR0 interrupt enable */
	mov #16,&0x162
	.dbline 162
;     CCR0 = 10000;                   /* 2,5 ms Timer Click */
	mov #10000,&0x172
	.dbline 163
;     TACTL |= MC0;                   /* Up-Mode */
	or #16,&0x160
	.dbline -2
	.dbline 164
;     }
L12:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e vTimerbInit _vTimerbInit fV
	.even
_vTimerbInit::
	.dbline -1
	.dbline 168
; 
; 
; /* Timer B, Telemetrie, Schrittmotoren */
; void vTimerbInit( void ){
	.dbline 169
;     TBCTL   = 0x00; //stop timer
	mov #0,&0x180
	.dbline 170
;     TBCCTL0 = 0x10;                 /* TBCCIE0 */
	mov #16,&0x182
	.dbline 171
;     TBCCR0  = 20000;                /* 2,5 ms Grundtakt */
	mov #20000,&0x192
	.dbline 172
;     TBCCTL1 = 0x10;//TBCCIE1
	mov #16,&0x184
	.dbline 173
;     TBCCR1  = 0x1000;                  /* SM1 */
	mov #4096,&0x194
	.dbline 174
;     TBCCTL2 = 0x10;//TBCCIE2
	mov #16,&0x186
	.dbline 175
;     TBCCR2  = 0x1000;                  /* SM2 */
	mov #4096,&0x196
	.dbline 177
;     //channel3
;     TBCCTL3 = 0x00;
	mov #0,&0x188
	.dbline 178
;     TBCCR3  = 0x00;
	mov #0,&0x198
	.dbline 180
;     //channel4
;     TBCCTL4 = 0x00;
	mov #0,&0x18a
	.dbline 181
;     TBCCR4  = 0x00;
	mov #0,&0x19a
	.dbline 183
;     //channel5
;     TBCCTL5 = 0x00;
	mov #0,&0x18c
	.dbline 184
;     TBCCR5  = 0x00;
	mov #0,&0x19c
	.dbline 186
;     //channel6
;     TBCCTL6 = 0x00;
	mov #0,&0x18e
	.dbline 187
;     TBCCR6  = 0x00;
	mov #0,&0x19e
	.dbline 188
;     TBR     = 0x0000;//clear timer counter
	mov #0,&0x190
	.dbline 189
;     TBCTL   = 0x226;//TBSSEL.1,TBMC.0,1,TBIE
	mov #550,&0x180
	.dbline -2
	.dbline 190
;     }
L13:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e vInitDevices _vInitDevices fV
	.even
_vInitDevices::
	.dbline -1
	.dbline 194
; 
; 
; /* call this routine to initialise all peripherals */
; void vInitDevices( void ){
	.dbline 195
;     DINT();                         /* disable all interrupts */
	dint
	.dbline 203
; //   ME1     = 0x00;                /* disable sfr peripherals */
; //   ME2     = 0x00;                /* disable sfr peripherals */
; //   IE1     = 0x00;                /* disable sfr interrupts */
; //   IE2     = 0x00;                /* disable sfr interrupts */
; 
; //   WDTCTL  = 0x5A | 0x15;         /* watchdog initialisation including nmi function */
; 
;     vClockInit();                   /* initialise other peripherals */
	call #_vClockInit
	.dbline 204
;     vPortInit();
	call #_vPortInit
	.dbline 205
;     vTimerbInit();
	call #_vTimerbInit
	.dbline -2
	.dbline 213
; //     vTimeraInit();                  /* was made by UEXEC */
; 
; //   ME1     = 0xC0;                /* enable sfr peripherals */
; //   ME2     = 0x00;                /* enable sfr peripherals */
; //   IE1     = 0xC0;                /* enable sfr interrupts */
; //   IE2     = 0x03;                /* disable sfr interrupts */
; //   EINT();                        /* re-enable interrupts */
;     }
L14:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e main _main fI
	.even
_main::
	sub #4,R1
	.dbline -1
	.dbline 223
; 
; 
; /***************************************************************************
; * Function  : Main-Loop
; *               - initialises peripherals
; *                - create tasks, start scheduler
; *
; * Author    : Jens Altenburg
; ****************************************************************************/
; int main(void){
	.dbline 224
;     vInitDevices();
	call #_vInitDevices
	.dbline 225
;     NAVI_vInit();
	call #_NAVI_vInit
	.dbline 226
;     TELE_vInit();
	call #_TELE_vInit
	.dbline 227
;     I2C_vInit();
	call #_I2C_vInit
	.dbline 229
; //    wTaskId0 = UEXC_CreateTask(vTask0, &abTask0[0], sizeof (abTask0), 1);
;     wTaskId1 = UEXC_CreateTask(TELE_vMain, &abTask1[0], sizeof (abTask1), 1);
	.dbline 230
;     wTaskId2 = UEXC_CreateTask(NAVI_vMain, &abTask2[0], sizeof (abTask2), 1);
	.dbline 231
;     UEXC_StartScheduler();
	mov #1,2(R1)
	mov #200,0(R1)
	mov #_abTask1,R15
	mov #_TELE_vMain,R14
	call #_UEXC_CreateTask
	mov R14,r13
	mov r14,_wTaskId1
	mov #1,2(R1)
	mov #200,0(R1)
	mov #_abTask2,R15
	mov #_NAVI_vMain,R14
	call #_UEXC_CreateTask
	mov R14,r13
	mov r14,_wTaskId2
	call #_UEXC_StartScheduler
	.dbline 232
;     return 1;                       /* avoid compiler warning */
	mov #1,R14
	.dbline -2
L15:
	add #4,R1
	.dbline 0 ; func end
	ret
	.dbend
	.area vector(abs)
	.org 0xffec
	.word _timera_0_isr
	.area text
	.dbfile C:\projekte\msp430\ct05\ct05.c
	.dbfunc e timera_0_isr _timera_0_isr fV
	.even
_timera_0_isr::
	.dbline -1
	.dbline 240
;     }
; 
; /***************************************************************************
; * Function  : timer controls cyclic scheduler call
; * Author    : Jens Altenburg
; ****************************************************************************/
; #pragma interrupt_handler timera_0_isr:TIMERA0_VECTOR
; void timera_0_isr(void){
	.dbline 241
;     CCR0 = 20000;                   /* 2,5 ms time slot */
	mov #20000,&0x172
	.dbline 242
;     P5OUT ^= 0x80;                  /* for diagnostic */
	xor.b #128,&0x31
	.dbline 243
; asm(
	 push  r4
	 push  r5
	 push  r6
	 push  r7
	 push  r8
	 push  r9
	 push  r10
	 push  r11
	 push  r12
	 push  r13
	 push  r14
	 push  r15
	 mov     SP,_uexc_current_sp
	 call    #_UEXC_CheckTask
	 pop   r15
	 pop   r14
	 pop   r13
	 pop   r12
	 pop   r11
	 pop   r10
	 pop   r9
	 pop   r8
	 pop   r7
	 pop   r6
	 pop   r5
	 pop   r4
	 reti
	
	.dbline -2
	.dbline 271
;      " push  r4\n"                   /* save CPU register */
;      " push  r5\n"
;      " push  r6\n"
;      " push  r7\n"
;      " push  r8\n"
;      " push  r9\n"
;      " push  r10\n"
;      " push  r11\n"
;      " push  r12\n"
;      " push  r13\n"
;      " push  r14\n"
;      " push  r15\n"
;      " mov     SP,%uexc_current_sp\n"  /* save stackpointer */
;      " call    #%UEXC_CheckTask\n"      /* check task state */
;      " pop   r15\n"                  /* restore register */
;      " pop   r14\n"
;      " pop   r13\n"
;      " pop   r12\n"
;      " pop   r11\n"
;      " pop   r10\n"
;      " pop   r9\n"
;      " pop   r8\n"
;      " pop   r7\n"
;      " pop   r6\n"
;      " pop   r5\n"
;      " pop   r4\n"
;      " reti\n");
;      }
L16:
	.dbline 0 ; func end
	reti
	.dbend
	.dbfunc e UEXC_StartTimer _UEXC_StartTimer fV
	.even
_UEXC_StartTimer::
	.dbline -1
	.dbline 277
; 
; /***************************************************************************
; * Function  : starts timer
; * Author    : Jens Altenburg
; ****************************************************************************/
; void UEXC_StartTimer(void){
	.dbline 278
;     vTimeraInit();
	call #_vTimeraInit
	.dbline 279
;     EINT();                            /* Scheduler enables interrupts */
	eint
	.dbline -2
	.dbline 280
;      }
L17:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e UEXC_SavregsAndResched _UEXC_SavregsAndResched fV
	.even
_UEXC_SavregsAndResched::
	.dbline -1
	.dbline 288
; 
; 
; /***************************************************************************
; * Function  : save state and then reschedule this called by Defer
; *             to give up control
; * Author    : Jens Altenburg
; ****************************************************************************/
; void UEXC_SavregsAndResched(void){
	.dbline 289
; asm(
	 mov     SR,_wRegister
	 bis     #8,_wRegister
	 push.w  _wRegister
	 push  r4
	 push  r5
	 push  r6
	 push  r7
	 push  r8
	 push  r9
	 push  r10
	 push  r11
	 push  r12
	 push  r13
	 push  r14
	 push  r15
	 mov.w   r15,_wRegister
	 mov.w   _uexc_current_sp,r15
	 mov.w     SP,(r15)
	 mov.w     _wRegister,r15
	 br   #_UEXC_Schedule
	
	.dbline -2
	.dbline 311
;      " mov     SR,%wRegister\n"           /* interrupt stack frame */
;      " bis     #8,%wRegister\n"               /* enable GIE */
;      " push.w  %wRegister\n"                  /* "SR" to stack */
;      " push  r4\n"
;      " push  r5\n"
;      " push  r6\n"
;      " push  r7\n"
;      " push  r8\n"
;      " push  r9\n"
;      " push  r10\n"
;      " push  r11\n"
;      " push  r12\n"
;      " push  r13\n"
;      " push  r14\n"
;      " push  r15\n"
;      " mov.w   r15,%wRegister\n"              /* r15 for indexed adressing */
;      " mov.w   %uexc_current_sp,r15\n"
;      " mov.w     SP,(r15)\n"                  /* save stackpointer */
;      " mov.w     %wRegister,r15\n"
;      " br   #%UEXC_Schedule\n"           /* Schedule */
;      );
;     }
L18:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e UEXC_StartNewTask _UEXC_StartNewTask fV
	.even
_UEXC_StartNewTask::
	.dbline -1
	.dbline 317
; 
; /***************************************************************************
; * Function  : start a new task
; * Author    : Jens Altenburg
; ****************************************************************************/
; void UEXC_StartNewTask(void){
	.dbline 318
; asm(
	 mov     _uexc_current_sp, SP
	 push.w  #_UEXC_KillSelf
	 push.w  _uexc_current_func
	 mov       SR,_wRegister
	 bis       #8,_wRegister
	 push.w  _wRegister
	 reti
	
	.dbline -2
	.dbline 327
;      " mov     %uexc_current_sp, SP\n"   /* moves content of uexc_cu.. to SP */
;      " push.w  #%UEXC_KillSelf\n"        /* Killself() onto stack */
;      " push.w  %uexc_current_func\n"          /* new function to stack */
;      " mov       SR,%wRegister\n"             /* Statusregister bearbeiten */
;      " bis       #8,%wRegister\n"             /* GIE */
;      " push.w  %wRegister\n"                  /* statusregister to stack */
;      " reti\n"                                /* go */
;      );
;     }
L19:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e UEXC_Resume _UEXC_Resume fV
	.even
_UEXC_Resume::
	.dbline -1
	.dbline 333
; 
; /***************************************************************************
; * Function  : Resume a previously stopped task
; * Author    : Jens Altenburg
; ****************************************************************************/
; void UEXC_Resume(void){
	.dbline 334
; asm(
	 mov     _uexc_current_sp, SP
	 pop   r15
	 pop   r14
	 pop   r13
	 pop   r12
	 pop   r11
	 pop   r10
	 pop   r9
	 pop   r8
	 pop   r7
	 pop   r6
	 pop   r5
	 pop   r4
	 reti
	
	.dbline -2
	.dbline 350
;      " mov     %uexc_current_sp, SP\n"    /* set Stackpointer */
;      " pop   r15\n"
;      " pop   r14\n"
;      " pop   r13\n"
;      " pop   r12\n"
;      " pop   r11\n"
;      " pop   r10\n"
;      " pop   r9\n"
;      " pop   r8\n"
;      " pop   r7\n"
;      " pop   r6\n"
;      " pop   r5\n"
;      " pop   r4\n"
;      " reti\n"                                /* ... */
;      );
;     }
L20:
	.dbline 0 ; func end
	ret
	.dbend
	.area vector(abs)
	.org 0xfffa
	.word _timerb_0_isr
	.area text
	.dbfile C:\projekte\msp430\ct05\ct05.c
	.dbfunc e timerb_0_isr _timerb_0_isr fV
	.even
_timerb_0_isr::
	.dbline -1
	.dbline 359
; 
; 
; 
; /***************************************************************************
; * Function  : Timer B0 arbeitet die Funktionspointerliste ab
; * Author    : Jens Altenburg
; ****************************************************************************/
; #pragma interrupt_handler timerb_0_isr:TIMERB0_VECTOR
; void timerb_0_isr(void){
	.dbline 360
;     TBCCR0 += 20000;
	add #20000,&0x192
	.dbline -2
	.dbline 362
;     //P2OUT  ^= 0x40;                /* for diagnostic */
;     }
L21:
	.dbline 0 ; func end
	reti
	.dbend
	.area vector(abs)
	.org 0xfff8
	.word _timerb_1_isr
	.area text
	.dbfile C:\projekte\msp430\ct05\ct05.c
	.dbfunc e timerb_1_isr _timerb_1_isr fV
	.even
_timerb_1_isr::
	push R10
	push R11
	push R12
	push R13
	push R4
	push R14
	push R15
	.dbline -1
	.dbline 369
; 
; /***************************************************************************
; * Function  : Schrittmotormodule
; * Author    : Jens Altenburg
; ****************************************************************************/
; #pragma interrupt_handler timerb_1_isr:TIMERB1_VECTOR
; void timerb_1_isr(void){
	.dbline 370
	mov &0x11e,R4
	cmp #2,R4
	jeq L26
	cmp #4,R4
	jeq L27
	cmp #6,R4
	jeq L28
	jmp L23
X0:
	.dbline 370
;     switch(TBIV){
L26:
	.dbline 372
;         case enTB1:
;             TBCCR1 += SMD_wMoveL(); /* Stepper links */ 
	call #_SMD_wMoveL
	mov R14,r13
	add r13,&0x194
	.dbline 373
;             break;
	jmp L24
L27:
	.dbline 375
;         case enTB2:
;             TBCCR2 += SMD_wMoveR(); /* Stepper rechts */
	call #_SMD_wMoveR
	mov R14,r13
	add r13,&0x196
	.dbline 376
;             break;
	jmp L24
L28:
	.dbline 378
;         case enTB3:
;             TBCCR3 += 0x6000; 
	add #24576,&0x198
	.dbline 380
;             //P2OUT ^= 0x08;
;             break;
L23:
L24:
	.dbline -2
	.dbline 382
;         }
;     }
L22:
	pop R15
	pop R14
	pop R4
	pop R13
	pop R12
	pop R11
	pop R10
	.dbline 0 ; func end
	reti
	.dbend
	.area bss
	.dbfile C:\projekte\msp430\ct05\ct05.c
_abTask2::
	.blkb 200
	.dbsym e abTask2 _abTask2 A[200:200]c
_abTask1::
	.blkb 200
	.dbsym e abTask1 _abTask1 A[200:200]c
_abTask0::
	.blkb 100
	.dbsym e abTask0 _abTask0 A[100:100]c
	.even
_wRegister::
	.blkb 2
	.dbsym e wRegister _wRegister i
	.even
_wTaskId2::
	.blkb 2
	.dbsym e wTaskId2 _wTaskId2 i
	.even
_wTaskId1::
	.blkb 2
	.dbsym e wTaskId1 _wTaskId1 i
	.even
_wTaskId0::
	.blkb 2
	.dbsym e wTaskId0 _wTaskId0 i
	.even
_stTimer::
	.blkb 2
	.dbsym e stTimer _stTimer X
	.area lit
	.even
	.area idata
	.even
	.area data
	.even
	.area bss
	.even
