/***************************************************************************
* Titel        : CAM.H
*
* Description  : Headerfile fuer Kameraansteuerung
*
* Environment  : Anpassung auf Mitsubishi M16C
*
* Responsible  : Jens Altenburg
*
* Guidelines   :
*
* Revision List:
  ----------------------------------------------------------------------------
  Date     | Author          | Change
  ----------------------------------------------------------------------------
  28.09.03 |J. Altenburg     | Ersterstellung
  ----------------------------------------------------------------------------
******************************************************************************/
/*
* Check if information are already included
*/
#ifndef I2C_H
#define I2C_H


/***************************************************************************
* HEADER-FILES (Only those that are needed in this file)
****************************************************************************/
/* System-headerfiles */
#include "cdef.h"                      /* General definitions and types */
#include "msp430x14x.h"

//#define I2CTEST                            /* Testmodus */


#define SCL()               (P6OUT |=  0x04) /* I2C CLK high SELECT_LN# = 0 -> SCL = 1 */
#define _SCL()              (P6OUT &= ~0x04) /* I2C CLK low  SELECT_LN# = 1 -> SCL = 0*/
#define SDA()               (P6OUT |=  0x08) /* I2C DATA high DA7 = 0 -> SDA = 1 */
#define _SDA()              (P6OUT &= ~0x08) /* I2C DATA low DA7 = 1 -> SDA = 0 */



/***************************************************************************
* Implementation       : Verzgerung
* Return Value         :
* Author               :
****************************************************************************/
void vDelay(byte);

/***************************************************************************
* Implementation       : Ein Byte schreiben
* Return Value         :
* Author               :
****************************************************************************/
void vWriteBi2c(byte);

/***************************************************************************
* Implementation       : Start einer I2C bertragung
* Return Value         :
* Author               :
****************************************************************************/
void vStarti2c(void);

/***************************************************************************
* Implementation       : Stop einer bertragung
* Return Value         :
* Author               :
****************************************************************************/
void vStopi2c(void);

/***************************************************************************
* Implementation       : Zeichenkette ber I2C senden
* Return Value         :
* Author               :
****************************************************************************/
void vSendI2C(byte, byte *);
void I2C_vInit( void );
void I2C_vState( byte );

/*
* End of check if information are already included
*/
#endif    

/***************************************************************************
* EOF: SWMODxC1.H
****************************************************************************/
