//ICC-MSP application builder [F149] : 15.02.2004 12:28:05
//Target 14x device

#include <msp430x14x.h>
#include <msp430def.h>

void clock_init()
{
  //DCO=0x00
 DCOCTL=0x00;
 BCSCTL2=0x88;//SELM.1,SELS
 BCSCTL1=0x00;
}

void port_init()
{
 P1OUT=0x00;
 P1DIR=0x00;
 P1IES=0x00;
 P1IE=0x00;
 P1SEL=0x00;
 P2OUT=0x00;
 P2DIR=0x00;
 P2IES=0x00;
 P2IE=0x00;
 P2SEL=0x00;
 P3OUT=0x00;
 P3DIR=0x00;
 P3SEL=0x00;
 P4OUT=0x00;
 P4DIR=0x00;
 P4SEL=0x00;
 P5OUT=0x00;
 P5DIR=0x00;
 P5SEL=0x00;
 P6OUT=0x00;
 P6DIR=0x00;
 P6SEL=0x00;
}

void timerb_init()
//Clock source=SMCLK
//Divider=1
//TIMBCLK=8,0000MHz
//Frequency=1000,00S (    0,0Hz)
{
 TBCTL=0x00; //stop timer
 //channel0
 TBCCTL0=0x10;//TBCCIE0
 TBCCR0=0x1F40;
 //channel1
 TBCCTL1=0x10;//TBCCIE1
 TBCCR1=0x1000;
 //channel2
 TBCCTL2=0x10;//TBCCIE2
 TBCCR2=0x1000;
 //channel3
 TBCCTL3=0x00;
 TBCCR3=0x00;
 //channel4
 TBCCTL4=0x00;
 TBCCR4=0x00;
 //channel5
 TBCCTL5=0x00;
 TBCCR5=0x00;
 //channel6
 TBCCTL6=0x00;
 TBCCR6=0x00;
 TBR=0x0000;//clear timer counter
 TBCTL=0x216;//TBSSEL.1,TBMC.0,1,TBIE
}

//call this routine to initialise all peripherals
void init_devices(void)
{
 //stop errant interrupts until set up
 DINT(); //disable all interrupts
 ME1=0X00; //disable sfr peripherals
 ME2=0X00; 
 IE1=0x00; //disable sfr interrupts
 IE2=0x00; 
 //watchdog initialisation including nmi function
 WDTCTL=0x5A00 | 0x00;
 //initialise other peripherals
 clock_init();
 port_init();
 timerb_init();

 ME1=0x00;
 ME2=0x00;
 IE1=0x00;
 IE2=0x00;
 EINT(); //re-enable interrupts
}

//interrupt handlers 

#pragma interrupt_handler timerb_0_isr:TIMERB0_VECTOR
void timerb_0_isr(void)
{
}

#pragma interrupt_handler timerb_1_isr:TIMERB1_VECTOR
void timerb_1_isr(void)
{
 //test TAIV
}

