/***************************************************************************
* Titel        : NAVI.H
*
* Description  : Header fr Navi-Task
*
* Environment  : ICC430 V6.05, MSP430F149
*
* Responsible  :
*
* Guidelines   :
*
* Revision List:
  --------------------------------------------------------------------------
  Date     | Author          | Change
  --------------------------------------------------------------------------
  12.02.04 |J. Altenburg     | fits to MSP430
  --------------------------------------------------------------------------
           |                 |
  --------------------------------------------------------------------------
****************************************************************************/
#ifndef NAVI_H
#define NAVI_H


/***************************************************************************
*   Enum, Defines, Prototypes
****************************************************************************/
typedef enum NAVI_enType{   /* Liste mglicher Job-Typen */
    enRobS = 0,             /* Stop */
    enRobF,                 /* Robot Forward */
    enRobB,                 /* Robot Bachward */
    enRobL,                 /* Robot Left */
    enRobR,                 /* Robot Right */
    enRobBl,                /* Bogen links */
    enRobBr                 /* Bogen rechts */
    }NAVI_enType;


typedef struct NAVI_stJob{
    NAVI_enType enType;     /* Job-Typ */
    word        wSpeed;     /* Gechwindigkeit */
    int32       iSteps;     /* Schrittzahl */
    }NAVI_stJob;


/***************************************************************************
*    Function Prototypes
****************************************************************************/
void NAVI_vInit ( void );
void NAVI_vMain ( void );
byte NAVI_bNewJob ( NAVI_stJob * );


#define nJobListSize        (7) /* Job-Liste */


#endif
