	.module navi.c
	.area text
	.dbfile C:\projekte\msp430\ct05\navi.c
	.dbfunc e NAVI_vInit _NAVI_vInit fV
	.even
_NAVI_vInit::
	.dbline -1
	.dbline 81
; /***************************************************************************
; * Titel        : NAVI.C
; *
; * Description  : Navigations-Task
; *
; * Environment  : ICC430 V6.05, MSP430F149
; *
; * Responsible  : J. Altenburg
; *
; * Guidelines   :
; *
; * Revision List:
;   --------------------------------------------------------------------------
;   Date     | Author          | Change
;   --------------------------------------------------------------------------
;   12.02.04 |J. Altenburg     | first release
;   --------------------------------------------------------------------------
;            |                 |
;   --------------------------------------------------------------------------
; ****************************************************************************/
; 
; /***************************************************************************
; * HEADER-FILES (Only those that are needed in this file)                   *
; ****************************************************************************/
; /* System-headerfiles */
; #include "cdef.h"                  /* General definitions and types */
; #include "msp430x14x.h"         /* MSP430 definitions */
; #include "msp430def.h"
; 
; /* Own headerfiles */
; #include "navi.h"
; 
; /* Foreign headerfiles */
; #include "smd.h"
; #include "i2c.h"
; 
; /***************************************************************************
; * Defines und Makros
; ****************************************************************************/
; 
; /***************************************************************************
; *    Local Function Prototypes
; ****************************************************************************/
; typedef void (* fLocalFunc)( void );    /* function pointer */
; 
; #define nLeftBit    0x01
; #define nRightBit   0x02
; #define nFullStep   0x00
; 
; /***************************************************************************
; *    Global Variables
; ****************************************************************************/
; byte bIndexToJob; /*
; * Description : gerade laufender Job
; */
; 
; byte bIndexToNextJob; /*
; * Description : nchster Job in der Liste
; */
; 
; NAVI_stJob stJobList[nJobListSize + 1]; /*
; * Description : Jobliste
; */
; 
; byte bJobState; /*
; * Description : Aktivitt eines Jobs
; */
; 
; NAVI_stJob stJob; /*
; * Description : Jobdaten 
; */
; 
; /***************************************************************************
; *    Code Area
; ****************************************************************************/
; /***************************************************************************
; *    Function:  NAVI-Init
; *
; *    Author:    Jens Altenburg
; ****************************************************************************/
; void NAVI_vInit( void ){
	.dbline 82
;     bIndexToJob = bIndexToNextJob = 0;
	.dbline 83
;     bJobState = 0;
	mov.b #0,_bIndexToNextJob
	mov.b #0,_bIndexToJob
	mov.b #0,_bJobState
	.dbline -2
	.dbline 84
;     }
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e vCallbackLeft _vCallbackLeft fV
	.even
_vCallbackLeft::
	.dbline -1
	.dbline 91
; 
; /***************************************************************************
; *    Function:  Callback-Left
; *
; *    Author:    Jens Altenburg
; ****************************************************************************/
; void vCallbackLeft( void ){
	.dbline 92
;     bJobState &= ~nLeftBit; /* Schrittmotor Links fertig */
	and.b #-2,_bJobState
	.dbline -2
	.dbline 93
;     }
L2:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e vCallbackRight _vCallbackRight fV
	.even
_vCallbackRight::
	.dbline -1
	.dbline 100
; 
; /***************************************************************************
; *    Function:  Callback-Right
; *
; *    Author:    Jens Altenburg
; ****************************************************************************/
; void vCallbackRight( void ){
	.dbline 101
;     bJobState &= ~nRightBit; /* rechts fertig */
	and.b #-3,_bJobState
	.dbline -2
	.dbline 102
;     }
L3:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e NAVI_bNewJob _NAVI_bNewJob fc
;              j -> R6
;              i -> R5
;          stJob -> R4
	.even
_NAVI_bNewJob::
	push R4
	push R5
	push R6
	mov R14,R4
	.dbline -1
	.dbline 109
; 
; /***************************************************************************
; *    Function:  trgt einen neuen Job in Liste ein (wenn Platz ist)
; *
; *    Author:    Jens Altenburg
; ****************************************************************************/
; byte NAVI_bNewJob (NAVI_stJob *stJob){
	.dbline 111
;     byte i, j;
;     i = bIndexToNextJob;
	.dbline 112
;     i++;                    /* Zeiger erhhen */
	.dbline 113
;     i &= nJobListSize;      /* auf richtige Gre maskieren */
	.dbline 114
;     j = bIndexToJob & nJobListSize; /* dito. fr den anderen Zeiger */
	.dbline 115
;     if(i == j){
	mov.b _bIndexToNextJob,R5
	add.b #1,R5
	and.b #7,R5
	mov.b _bIndexToJob,R6
	and.b #7,R6
	cmp.b R6,R5
	jne L5
	.dbline 115
	.dbline 116
;         return False;       /* Liste voll */
	mov.b #0,R14
	jmp L4
L5:
	.dbline 118
;         }
;     else{
	.dbline 119
;         stJobList[i] = *stJob; /* Job eintragen */
	mov #_stJobList,R13
	mov R5,R12
	and #255,R12
	add R12,R12
	add R12,R12
	add R12,R12
	add R13,R12
	mov #8,R14
	push R14
	mov R4,R14
	mov R12,R15
	call #asgnblk
	.dbline 120
;         bIndexToNextJob++;
	.dbline 121
;         return True;        /* erledigt */
	add.b #1,_bIndexToNextJob
	mov.b #1,R14
	.dbline -2
L4:
	pop R6
	pop R5
	pop R4
	.dbline 0 ; func end
	ret
	.dbsym r j 6 c
	.dbsym r i 5 c
	.dbsym r stJob 4 pX
	.dbend
	.dbfunc e NAVI_vMain _NAVI_vMain fV
;             iS -> 10(SP)
;             wS -> <dead>
;             dw -> 14(SP)
	.even
_NAVI_vMain::
	push R4
	sub #18,R1
	.dbline -1
	.dbline 129
;         }
;     }
; 
; /***************************************************************************
; *    Function:  NAVI-Task
; *    Author:    Jens Altenburg
; ****************************************************************************/
; void NAVI_vMain( void ){
	jmp L9
L8:
	.dbline 133
;     dword dw;
;     word  wS; /* Geschwindigkeit */
;     int32 iS; /* Schritte */
;     while(1){
	.dbline 135
; #if 1
;         P5OUT ^= 0x02;
	xor.b #2,&0x31
	.dbline 136
;         if(bIndexToJob != bIndexToNextJob){
	cmp.b _bIndexToNextJob,_bIndexToJob
	jeq L11
	.dbline 136
	.dbline 137
;             bIndexToJob++;
	.dbline 138
;             stJob = stJobList[bIndexToJob & nJobListSize];
	.dbline 139
;             bJobState = nLeftBit + nRightBit;   /* Job aktiv */
	.dbline 140
	add.b #1,_bIndexToJob
	mov #_stJobList,R13
	mov.b _bIndexToJob,R12
	and #7,R12
	add R12,R12
	add R12,R12
	add R12,R12
	add R13,R12
	mov #_stJob,R13
	mov #8,R14
	push R14
	mov R12,R14
	mov R13,R15
	call #asgnblk
	mov.b #3,_bJobState
	mov.b _stJob,R4
	and #255,R4
	cmp #0,R4
	jeq L16
	cmp #1,R4
	jeq L19
	cmp #2,R4
	jeq L24
	cmp #3,R4
	jeq L29
	cmp #4,R4
	jeq L34
	cmp #5,R4
	jeq L39
	cmp #6,R4
	jeq L40
	jmp L13
X0:
	.dbline 140
;             switch(stJob.enType){
L16:
	.dbline 142
;                 case enRobS:                    /* Stop */
;                     SMD_vStartL(vCallbackLeft,  nFullStep, stJob.wSpeed, 0);
	mov #0,2(R1)
	mov #0,4(R1)
	mov _stJob+2,0(R1)
	mov.b #0,R15
	mov #_vCallbackLeft,R14
	call #_SMD_vStartL
	.dbline 143
;                     SMD_vStartR(vCallbackRight, nFullStep, stJob.wSpeed, 0);
	mov #0,2(R1)
	mov #0,4(R1)
	mov _stJob+2,0(R1)
	mov.b #0,R15
	mov #_vCallbackRight,R14
	call #_SMD_vStartR
	.dbline 144
;                     I2C_vState(1);
	mov.b #1,R14
	call #_I2C_vState
	.dbline 145
;                     break;
	jmp L42
L19:
	.dbline 147
;                 case enRobF:                    /* Robot Forward */
;                     SMD_vStartL(vCallbackLeft,  nFullStep, stJob.wSpeed, stJob.iSteps);
	mov _stJob+4,2(R1)
	mov _stJob+4+2,4(R1)
	mov _stJob+2,0(R1)
	mov.b #0,R15
	mov #_vCallbackLeft,R14
	call #_SMD_vStartL
	.dbline 148
;                     SMD_vStartR(vCallbackRight, nFullStep, stJob.wSpeed, stJob.iSteps);
	mov _stJob+4,2(R1)
	mov _stJob+4+2,4(R1)
	mov _stJob+2,0(R1)
	mov.b #0,R15
	mov #_vCallbackRight,R14
	call #_SMD_vStartR
	.dbline 149
;                     I2C_vState(2);
	mov.b #2,R14
	call #_I2C_vState
	.dbline 150
;                     break;
	jmp L42
L24:
	.dbline 152
;                 case enRobB:                    /* Robot Bachward */
;                     SMD_vStartL(vCallbackLeft,  nFullStep, stJob.wSpeed, stJob.iSteps * -1);
	mov #-1,R14
	mov #-1,R15
	push _stJob+4+2
	push _stJob+4
	call #emul32
	mov R14,2(R1)
	mov R15,4(R1)
	mov _stJob+2,0(R1)
	mov.b #0,R15
	mov #_vCallbackLeft,R14
	call #_SMD_vStartL
	.dbline 153
;                     SMD_vStartR(vCallbackRight, nFullStep, stJob.wSpeed, stJob.iSteps * -1);
	mov #-1,R14
	mov #-1,R15
	push _stJob+4+2
	push _stJob+4
	call #emul32
	mov R14,2(R1)
	mov R15,4(R1)
	mov _stJob+2,0(R1)
	mov.b #0,R15
	mov #_vCallbackRight,R14
	call #_SMD_vStartR
	.dbline 154
;                     I2C_vState(3);
	mov.b #3,R14
	call #_I2C_vState
	.dbline 155
;                     break;
	jmp L42
L29:
	.dbline 157
;                 case enRobL:                    /* Robot Left */
;                     SMD_vStartL(vCallbackLeft,  nFullStep, stJob.wSpeed, stJob.iSteps * -1);
	mov #-1,R14
	mov #-1,R15
	push _stJob+4+2
	push _stJob+4
	call #emul32
	mov R14,2(R1)
	mov R15,4(R1)
	mov _stJob+2,0(R1)
	mov.b #0,R15
	mov #_vCallbackLeft,R14
	call #_SMD_vStartL
	.dbline 158
;                     SMD_vStartR(vCallbackRight, nFullStep, stJob.wSpeed, stJob.iSteps);
	mov _stJob+4,2(R1)
	mov _stJob+4+2,4(R1)
	mov _stJob+2,0(R1)
	mov.b #0,R15
	mov #_vCallbackRight,R14
	call #_SMD_vStartR
	.dbline 159
;                     I2C_vState(4);
	mov.b #4,R14
	call #_I2C_vState
	.dbline 160
;                     break;
	jmp L42
L34:
	.dbline 162
;                 case enRobR:                    /* Robot Right */
;                     SMD_vStartL(vCallbackLeft,  nFullStep, stJob.wSpeed, stJob.iSteps);
	mov _stJob+4,2(R1)
	mov _stJob+4+2,4(R1)
	mov _stJob+2,0(R1)
	mov.b #0,R15
	mov #_vCallbackLeft,R14
	call #_SMD_vStartL
	.dbline 163
;                     SMD_vStartR(vCallbackRight, nFullStep, stJob.wSpeed, stJob.iSteps * -1);
	mov #-1,R14
	mov #-1,R15
	push _stJob+4+2
	push _stJob+4
	call #emul32
	mov R14,2(R1)
	mov R15,4(R1)
	mov _stJob+2,0(R1)
	mov.b #0,R15
	mov #_vCallbackRight,R14
	call #_SMD_vStartR
	.dbline 164
;                     I2C_vState(5);
	mov.b #5,R14
	call #_I2C_vState
	.dbline 165
;                     break;
	jmp L42
L39:
	.dbline 167
;                 case enRobBl:                   /* Bogen links */
;                     SMD_vStartL(vCallbackLeft,  nFullStep, 25500, 1370);
	mov #1370,2(R1)
	mov #0,4(R1)
	mov #25500,0(R1)
	mov.b #0,R15
	mov #_vCallbackLeft,R14
	call #_SMD_vStartL
	.dbline 168
;                     SMD_vStartR(vCallbackRight, nFullStep, 15000, 2340);
	mov #2340,2(R1)
	mov #0,4(R1)
	mov #15000,0(R1)
	mov.b #0,R15
	mov #_vCallbackRight,R14
	call #_SMD_vStartR
	.dbline 169
;                     I2C_vState(6);
	mov.b #6,R14
	call #_I2C_vState
	.dbline 170
;                     break;
	jmp L42
L40:
	.dbline 172
;                 case enRobBr:                   /* Bogen rechts */
;                     SMD_vStartL(vCallbackLeft,  nFullStep, 15000, 2340);
	mov #2340,2(R1)
	mov #0,4(R1)
	mov #15000,0(R1)
	mov.b #0,R15
	mov #_vCallbackLeft,R14
	call #_SMD_vStartL
	.dbline 173
;                     SMD_vStartR(vCallbackRight, nFullStep, 25500, 1370);
	mov #1370,2(R1)
	mov #0,4(R1)
	mov #25500,0(R1)
	mov.b #0,R15
	mov #_vCallbackRight,R14
	call #_SMD_vStartR
	.dbline 174
;                     I2C_vState(7);
	mov.b #7,R14
	call #_I2C_vState
	.dbline 175
;                     break;
	jmp L42
L13:
	.dbline 177
;                 default:
;                     bJobState = 0;
	mov.b #0,_bJobState
	.dbline 178
;                     break;
L41:
	.dbline 180
L42:
	.dbline 180
;                 }
;             while(bJobState);                   /* ich haben fertig */
	cmp.b #0,_bJobState
	jne L41
	.dbline 181
;             dw = 1000;                         /* have a break, have a ... */
	mov #1000,14(R1)
	mov #0,16(R1)
L44:
	.dbline 182
L45:
	.dbline 182
;             while(dw--); 
	mov 16(R1),8(R1)
	mov 14(R1),6(R1)
	mov 6(R1),R12
	mov 8(R1),R13
	sub #1,R12
	subc #0,R13
	mov R12,14(R1)
	mov R13,16(R1)
	mov #0,R14
	mov #0,R15
	push 10(R1)
	push 10(R1)
	call #cmp32
	jne L44
	.dbline 183
;             }
L11:
	.dbline 194
L9:
	.dbline 133
	jmp L8
X1:
	.dbline -2
	.dbline 195
; #else
;             //DINT(); 
;             SMD_vStartL(vCallbackLeft,  nFullStep, 35000,  -120);
;             SMD_vStartR(vCallbackRight, nFullStep, 35000,  120);
;             //EINT();
;             bJobState = nRightBit + nLeftBit; 
;             while(bJobState);
;             dw = 80000;
;             while(dw--); 
; #endif
;         }
;     }
L7:
	add #18,R1
	pop R4
	.dbline 0 ; func end
	ret
	.dbsym l iS 10 L
	.dbsym l wS 17 i
	.dbsym l dw 14 l
	.dbend
	.area bss
	.dbfile C:\projekte\msp430\ct05\navi.c
	.even
_stJob::
	.blkb 8
	.dbsym e stJob _stJob X
_bJobState::
	.blkb 1
	.dbsym e bJobState _bJobState c
	.even
_stJobList::
	.blkb 64
	.dbsym e stJobList _stJobList A[64:8]X
_bIndexToNextJob::
	.blkb 1
	.dbsym e bIndexToNextJob _bIndexToNextJob c
_bIndexToJob::
	.blkb 1
	.dbsym e bIndexToJob _bIndexToJob c
	.area lit
	.even
	.area idata
	.even
	.area data
	.even
	.area bss
	.even
