	.module rf433.c
	.area text
	.dbfile C:\projekte\msp430\ct05\rf433.c
	.dbfunc e vRxDummy _vRxDummy fV
;              i -> R14
	.even
_vRxDummy::
	.dbline -1
	.dbline 110
; /***************************************************************************
; * Titel        : RF4.C
; *
; * Description  : Ansteuerung fr nRF903, 433MHz
; *
; * Environment  :
; *
; * Responsible  : J. Altenburg
; *
; * Guidelines   :
; *
; * Revision List:
;   --------------------------------------------------------------------------
;   Date     | Author          | Change
;   --------------------------------------------------------------------------
;   10.06.03 |J. Altenburg     | Ersterstellung
;   --------------------------------------------------------------------------
;            |                 |
;   --------------------------------------------------------------------------
; ****************************************************************************/
; 
; /***************************************************************************
; * HEADER-FILES (Only those that are needed in this file)                   *
; ****************************************************************************/
; /* System-headerfiles */
; #include "cdef.h"                      /* General definitions and types */
; 
; /* Own headerfiles */
; #include "rf433.h"
; 
; /* Foreign headerfiles */
; 
; /***************************************************************************
; *    Variablen                                                             *
; ****************************************************************************/
; byte bRfState; /*
; * Description : Variable fr Zustandsautomat
; */
; 
; byte bTimeout; /*
; * Description : Timeoutzhler
; */
; 
; fCallBackRx fRxFunc; /*
; * Description : Callbackfunktion fr Rx-Interruptservice
; */
; 
; byte *pTxBuffer; /*
; * Description : Zeiger auf Sendepuffer
; */
; 
; byte bTxIndex; /*
; * Description : Anzahl der zu sendenden Zeichen
; */
; 
; enTxState enState; /*
; * Description : Zustand der Senderoutine
; */
; 
; byte bSyncCount; /*
; * Description : Sync-Zeichenzhler
; */
; 
; byte bTxState; /*
; * Description : Zustandsautomat Tx-ISR
; */
; 
; /* Zugriffsmakros fr Merkflags */
; 
; /***************************************************************************
; * Defines und Makros Zugriff                                               *
; ****************************************************************************/
; #define nDefault433      0xf000    /* Defaultwert fr Configurationswort */
; #define nMaxChannel      9         /* Anzahl der HF-Kanle */
; #define nOneSecond       100       /* eine Sekunde */
; 
; #define vRxLedOn()       (P2OUT &= ~0x40)
; #define vRxLedOff()      (P2OUT |=  0x40)
; #define vTxLedOn()       (P2OUT &= ~0x80)
; #define vTxLedOff()      (P2OUT |=  0x80)
; 
; #define nSync            0xCC      /* Sync-Zeichen */
; #define nSyncEnd         0xF0      /* letztes Sync-Zeichen */
; #define nSyncTime        76        /* 76 x 0xcc = 10 ms (76,2 kBaud) */
; 
; enum {
;      enRfInit = 0,                 /* tut nix */
;      enRfCheckCarrier,             /* Test auf Trger */
;      enRfPrepareRx,                /* Empfangsmode vorbereiten */
;      enRfReceive,                  /* Empfangsmode */
;      enRfPrepareTx,                /* Sendemode vorbereiten */
;      enRfTransmit                  /* Senden */
;      };
; 
; enum {
;      enTxSync = 0,                 /* TX-ISR sendet Sync-Zeichen */
;      enTxSyncEnd,
;      enTxMessage,                  /* Botschaft wird gesendet */
;      enTxOff                       /* Tx-ISR beenden */
;      };
; 
; /***************************************************************************
; *    Code                                                                  *
; ****************************************************************************/
; 
; /***************************************************************************
; *    Funktion: Dummy fr Empfangsroutine                                   *
; *    Autor:    Jens Altenburg                                              *
; ****************************************************************************/
; void vRxDummy( byte i ){
	.dbline 111
;       i++;        /* */
	add.b #1,R14
	.dbline -2
	.dbline 112
;       }
L3:
	.dbline 0 ; func end
	ret
	.dbsym r i 14 c
	.dbend
	.dbfunc e vSendCfg _vSendCfg fV
;              i -> R5
;           wCfg -> R4
	.even
_vSendCfg::
	push R4
	push R5
	mov R14,R4
	.dbline -1
	.dbline 118
; 
; /***************************************************************************
; *    Funktion: schickt die Configurationsdaten zum nRF903                  *
; *    Autor:    Jens Altenburg                                              *
; ****************************************************************************/
; void vSendCfg(word wCfg){
	.dbline 120
;      byte i;
;      CFG_CS(1);                              /* CFG-Mode enabled */
	mov.b &0x1d,R13
	and #223,R13
	or #32,R13
	mov.b R13,&0x1d
	.dbline 121
	mov.b #15,R5
	jmp L8
L5:
	.dbline 121
;      for(i = 15; i > 1; i--){
	.dbline 122
;           CFG_CLK(0);
	and.b #239,&0x1d
	.dbline 123
;           if(wCfg & (1 << i)){               /* Datenbit setzen */
	mov R5,R13
	and #255,R13
	mov R13,R15
	mov #1,R14
	call #lsl16
	mov R14,R13
	bit R13,R4
	jeq L9
	.dbline 123
	.dbline 124
;                CFG_DATA(1);
	mov.b &0x1d,R13
	and #247,R13
	or #8,R13
	mov.b R13,&0x1d
	.dbline 125
;                }
	jmp L10
L9:
	.dbline 126
;           else CFG_DATA(0);
	and.b #247,&0x1d
L10:
	.dbline 127
	mov.b &0x1d,R13
	and #239,R13
	or #16,R13
	mov.b R13,&0x1d
	.dbline 128
L6:
	.dbline 121
	sub.b #1,R5
L8:
	.dbline 121
	mov.b #1,R13
	cmp.b R5,R13
	jlo L5
	.dbline 129
;           CFG_CLK(1);                        /* einschieben */
;           }
;      i++;                                    /* Dummy-Code, kurze Zeit */
	.dbline 130
;      CFG_CLK(0);
	add.b #1,R5
	and.b #207,&0x1d
	.dbline 131
;      CFG_CS(0);                              /* CFG-Mode disable */
	.dbline -2
	.dbline 132
;      }
L4:
	pop R5
	pop R4
	.dbline 0 ; func end
	ret
	.dbsym r i 5 c
	.dbsym r wCfg 4 i
	.dbend
	.dbfunc e RF4_vClearState _RF4_vClearState fV
	.even
_RF4_vClearState::
	.dbline -1
	.dbline 139
; 
; /***************************************************************************
; *    Funktion: Initialisiert enState                                       *
; *                                                                          *
; *    Autor:    Jens Altenburg                                              *
; ****************************************************************************/
; void RF4_vClearState( void ){
	.dbline 140
;      enState = enTxReady;
	mov.b #0,_enState
	.dbline -2
	.dbline 141
;      }
L11:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e RF4_vInit _RF4_vInit fV
	.even
_RF4_vInit::
	.dbline -1
	.dbline 148
; 
; /***************************************************************************
; *    Funktion: Initialisierung                                             *
; *                                                                          *
; *    Autor:    Jens Altenburg                                              *
; ****************************************************************************/
; void RF4_vInit( void ){
	.dbline 149
;      bTxIndex = 0;
	.dbline 150
;      fRxFunc = vRxDummy;                     /* Callbackfunktion initialisieren */
	.dbline 152
;      /* UART einstellen 76,2 kBaud */
;      U0CTL   = CHAR;                         /* 8-Bit Zeichen */
	mov.b #0,_bTxIndex
	mov #_vRxDummy,R13
	mov R13,_fRxFunc
	mov.b #16,&0x70
	.dbline 153
;      U0TCTL  = SSEL1;                        /* UCLK = SMCLK */
	mov.b #32,&0x71
	.dbline 155
; //   URCTL0  = URXEIE;                       /* Empfangsinterrupt */
;      U0BR0   = 0x69;
	mov.b #105,&0x74
	.dbline 156
;      U0BR1   = 0x00;
	mov.b #0,&0x75
	.dbline 158
; //   UMCTL0  = 0x00;
;      ME1 |= UTXE0 + URXE0; /* UART0 enable */
	or.b #192,&0x4
	.dbline 159
;      bRfState = enRfInit;
	.dbline 160
;      enState = enTxReady;
	mov.b #0,_bRfState
	mov.b #0,_enState
	.dbline -2
	.dbline 161
;      }
L12:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e RF4_boOpen _RF4_boOpen fc
;       wCfgData -> R5
;       bChannel -> R6
;            fRx -> R4
	.even
_RF4_boOpen::
	push R4
	push R5
	push R6
	mov R15,R6
	mov R14,R4
	.dbline -1
	.dbline 170
; 
; /***************************************************************************
; *    Funktion: Kommunikationsinterface zum RF-Modul ffnen                 *
; *              es wird automatisch versucht empfangswrdige Zeichen        *
; *              an die Callbackfunktion zu bergeben, d.h. der Empfnger    *
; *              ist aktiv                                                   *
; *    Autor:    Jens Altenburg                                              *
; ****************************************************************************/
; bool RF4_boOpen ( fCallBackRx fRx, byte bChannel ){
	.dbline 171
;      word wCfgData = nDefault433;
	mov #61440,R5
	.dbline 172
;      if(fRxFunc == vRxDummy){
	mov #_vRxDummy,R13
	cmp R13,_fRxFunc
	jne L14
	.dbline 172
	.dbline 173
;           STBY(0);                 /* Einschalten des nRF903 */
	and.b #192,&0x1d
	.dbline 174
;           PWR_DWN(0);
	.dbline 175
;           TXEN(0);
	.dbline 176
;           CFG_CS(0);
	.dbline 177
;           CFG_DATA(0);
	.dbline 178
;           CFG_CLK(0);
	.dbline 179
;           if(bChannel > nMaxChannel){
	mov.b #9,R13
	cmp.b R6,R13
	jhs L16
	.dbline 179
	.dbline 180
;                bChannel = nMaxChannel;
	mov R13,R6
	.dbline 181
;                }
L16:
	.dbline 182
;           wCfgData = wCfgData | (bChannel << 4);  /* Konfigdaten aufodern */
	.dbline 183
;           vSendCfg(wCfgData);      /* nRF903 initialisieren */
	mov R6,R13
	and #255,R13
	add R13,R13
	add R13,R13
	add R13,R13
	add R13,R13
	or R13,R5
	mov R5,R14
	call #_vSendCfg
	.dbline 184
;           STBY(1);                 /* nRF903 im Standby-Mode */
	mov.b &0x1d,R13
	and #253,R13
	or #2,R13
	mov.b R13,&0x1d
	.dbline 185
;           mcDisInt();              /* Interrupt sperren */
	dint
	.dbline 186
;           fRxFunc = fRx;           /* Callback-Funktion zuweisen */
	.dbline 187
;           bTxIndex = 0;            /* sicherheitshalber */
	.dbline 188
;           mcEnaInt();
	mov R4,_fRxFunc
	mov.b #0,_bTxIndex
	eint
	.dbline 189
;           STBY(0);
	and.b #248,&0x1d
	.dbline 190
;           PWR_DWN(0);
	.dbline 191
;           TXEN(0);
	.dbline 192
;           bRfState = enRfCheckCarrier;
	.dbline 193
;           return True;
	mov.b #1,_bRfState
	mov.b #1,R14
	jmp L13
L14:
	.dbline 195
;           }
;      else return False;
	mov.b #0,R14
	.dbline -2
L13:
	pop R6
	pop R5
	pop R4
	.dbline 0 ; func end
	ret
	.dbsym r wCfgData 5 i
	.dbsym r bChannel 6 c
	.dbsym r fRx 4 pfV
	.dbend
	.dbfunc e RF4_boClose _RF4_boClose fc
;            fRx -> R4
	.even
_RF4_boClose::
	push R4
	mov R14,R4
	.dbline -1
	.dbline 202
;      }
; 
; /***************************************************************************
; *    Funktion: Kommunikationsinterface freigeben                           *
; *    Autor:    Jens Altenburg                                              *
; ****************************************************************************/
; bool RF4_boClose ( fCallBackRx fRx ){
	.dbline 203
;      if(fRxFunc == fRx){
	cmp R4,_fRxFunc
	jne L19
	.dbline 203
	.dbline 204
;           mcDisInt();              /* Interrupt sperren */
	dint
	.dbline 205
;           fRxFunc = vRxDummy;      /* Callback-Funktionen freigeben */
	.dbline 206
;           IE1 &= ~(UTXIE0 + URXIE0);
	mov #_vRxDummy,R13
	mov R13,_fRxFunc
	and.b #-193,&0
	.dbline 207
;           mcEnaInt();
	eint
	.dbline 208
;           bRfState = enRfInit;
	.dbline 209
;           return True;
	mov.b #0,_bRfState
	mov.b #1,R14
	jmp L18
L19:
	.dbline 211
;           }
;      else return False;
	mov.b #0,R14
	.dbline -2
L18:
	pop R4
	.dbline 0 ; func end
	ret
	.dbsym r fRx 4 pfV
	.dbend
	.dbfunc e RF4_enSendMessage _RF4_enSendMessage fc
;          pBuff -> R15
;          bSize -> R4
	.even
_RF4_enSendMessage::
	push R4
	mov R14,R4
	.dbline -1
	.dbline 220
;      }
; 
; 
; /***************************************************************************
; *    Funktion: bergibt eine Message und liefert den Status zurck         *
; *                                                                          *                                                                          *
; *    Autor:    Jens Altenburg                                              *
; ****************************************************************************/
; enTxState RF4_enSendMessage( byte bSize, byte *pBuff ){
	.dbline 221
;      if(enState == enTxReady){
	cmp.b #0,_enState
	jne L22
	.dbline 221
	.dbline 222
;           if(bSize == 0){
	cmp.b #0,R4
	jne L24
	.dbline 222
	.dbline 223
;                return enTxError;   /* nicht erlaubt */
	mov.b #4,R14
	jmp L21
L24:
	.dbline 225
;                }
;           else {                   /* Senden vorbereiten */
	.dbline 226
;                bTxIndex = bSize;
	.dbline 227
;                pTxBuffer = pBuff;
	.dbline 228
;                enState = enTxPending;
	.dbline 229
;                return enState;     /* Vorbereitungsmode */
	mov.b R4,_bTxIndex
	mov R15,_pTxBuffer
	mov.b #1,_enState
	mov.b _enState,R14
	jmp L21
L22:
	.dbline 232
;                }
;           }
;      else return enState;          /* Rckgabe Status */
	mov.b _enState,R14
	.dbline -2
L21:
	pop R4
	.dbline 0 ; func end
	ret
	.dbsym r pBuff 15 pc
	.dbsym r bSize 4 c
	.dbend
	.dbfunc e RF4_vMain _RF4_vMain fV
	.even
_RF4_vMain::
	push R4
	.dbline -1
	.dbline 240
;      }
; 
; /***************************************************************************
; *    Funktion: Main-Loop, Aufruf alle 2,5 ms                                *
; *                                                                          *
; *    Autor:    Jens Altenburg                                              *
; ****************************************************************************/
; void RF4_vMain( void ){
	.dbline 241
	mov.b _bRfState,R4
	and #255,R4
	cmp #0,R4
	jeq L30
	cmp #1,R4
	jeq L31
	cmp #2,R4
	jeq L36
	cmp #3,R4
	jeq L39
	cmp #4,R4
	jeq L42
	cmp #5,R4
	jeq L43
	jmp L27
X0:
	.dbline 241
;      switch(bRfState){
L27:
L30:
	.dbline 244
;           default:
;           case enRfInit:           /* tut nix */
;                STBY(1);            /* Strom sparen */
	mov.b &0x1d,R13
	and #253,R13
	or #2,R13
	mov.b R13,&0x1d
	.dbline 245
;                break;
	jmp L28
L31:
	.dbline 248
;           case enRfCheckCarrier:   /* Test auf Trger */
; #ifdef RFTEST
;                vRxLedOff();
	or.b #192,&0x29
	.dbline 249
;                vTxLedOff();
	.dbline 251
; #endif
;                TXEN(0);            /* Empfangsmode */
	and.b #251,&0x1d
	.dbline 252
;                if(C_SENSE){        /* Ist ein Trger aktiv ? */
	bit.b #128,&0x1c
	jeq L32
	.dbline 252
	.dbline 253
;                     bRfState = enRfPrepareRx; /* Ja! */
	mov.b #2,_bRfState
	.dbline 254
;                     }
	jmp L28
L32:
	.dbline 255
;                else {              /* Soll gesendet werden ? */
	.dbline 256
;                     if(enState == enTxPending){ /* Ja ! */
	cmp.b #1,_enState
	jne L28
	.dbline 256
	.dbline 257
;                          TXEN(1);  /* Sender einschalten */
	mov.b &0x1d,R13
	and #251,R13
	or #4,R13
	mov.b R13,&0x1d
	.dbline 258
;                          bRfState = enRfPrepareTx; /* Zustand weiterschalten */
	.dbline 259
;                          enState = enTxBusy;
	.dbline 261
; #ifdef RFTEST
;                          vTxLedOn();
	mov.b #4,_bRfState
	mov.b #2,_enState
	and.b #-129,&0x29
	.dbline 263
; #endif
;                          }
	.dbline 264
;                     }
	.dbline 265
;                break;
	jmp L28
L36:
	.dbline 267
;           case enRfPrepareRx:      /* Empfangsmode vorbereiten */
;                if(C_SENSE){        /* ist der Trger immer noch vorhanden ? */
	bit.b #128,&0x1c
	jeq L37
	.dbline 267
	.dbline 268
;                     mcDisInt();
	dint
	.dbline 269
;                     IE1 |= URXIE0; /* Rx-Interrupt freigeben */
	or.b #64,&0
	.dbline 270
;                     mcEnaInt();
	eint
	.dbline 271
;                     bRfState = enRfReceive;
	.dbline 273
; #ifdef RFTEST
;                     vRxLedOn();
	mov.b #3,_bRfState
	and.b #-65,&0x29
	.dbline 275
; #endif
;                     }
	jmp L28
L37:
	.dbline 276
;                else {
	.dbline 277
;                     bRfState = enRfCheckCarrier;
	mov.b #1,_bRfState
	.dbline 278
;                     }
	.dbline 279
;                break;
	jmp L28
L39:
	.dbline 281
;           case enRfReceive:        /* Empfangsmode */
;                if(!C_SENSE){       /* wenn der Trger weg ist, abschalten */
	bit.b #128,&0x1c
	jne L28
	.dbline 281
	.dbline 282
;                     mcDisInt();
	dint
	.dbline 283
;                     IE1 &= ~URXIE0;/* Empfangsinterrupt sperren */
	and.b #-65,&0
	.dbline 284
;                     mcEnaInt();
	eint
	.dbline 285
;                     bRfState = enRfCheckCarrier;
	mov.b #1,_bRfState
	.dbline 286
;                     }
	.dbline 287
;                break;
	jmp L28
L42:
	.dbline 289
;           case enRfPrepareTx:      /* Interrupt vorbereiten */
;                mcDisInt();
	dint
	.dbline 290
;                IE1 &= ~URXIE0;     /* Rx-Int. sperren */
	and.b #-65,&0
	.dbline 291
;                IE1 |= UTXIE0;      /* Tx-Int. freigeben */
	or.b #128,&0
	.dbline 292
;                mcEnaInt();
	eint
	.dbline 293
;                bRfState = enRfTransmit;
	.dbline 294
;                bTxState = enTxSync;
	.dbline 295
;                bSyncCount = nSyncTime;
	.dbline 296
;                U0TXBUF = nSync;    /* Start x-ISR */
	mov.b #5,_bRfState
	mov.b #0,_bTxState
	mov.b #76,_bSyncCount
	mov.b #204,&0x77
	.dbline 297
;                bTimeout = 0;
	mov.b #0,_bTimeout
	.dbline 298
;                break;
	jmp L28
L43:
	.dbline 300
	.dbline 301
	add.b #1,_bTimeout
	mov.b #100,R13
	cmp.b _bTimeout,R13
	jhs L28
	.dbline 301
	.dbline 302
	.dbline 303
	.dbline 304
	mov.b #3,_enState
	mov.b #1,_bRfState
	and.b #251,&0x1d
	.dbline 305
	dint
	.dbline 306
	and.b #-129,&0
	.dbline 307
	eint
	.dbline 308
	.dbline 309
L28:
	.dbline -2
	.dbline 311
;           case enRfTransmit:       /* Senden */
;                bTimeout++;
;                if(bTimeout > nOneSecond){
;                     enState = enTxTimeOut;
;                     bRfState = enRfCheckCarrier;
;                     TXEN(0);       /* Sender aus */
;                     mcDisInt();
;                     IE1 &= ~UTXIE0;/* Tx-Interrupt sperren */
;                     mcEnaInt();
;                     }
;                break;
;           }
;      }
L26:
	pop R4
	.dbline 0 ; func end
	ret
	.dbend
	.area vector(abs)
	.org 0xfff0
	.word _uart0_tx_isr
	.area text
	.dbfile C:\projekte\msp430\ct05\rf433.c
	.dbfunc e uart0_tx_isr _uart0_tx_isr fV
	.even
_uart0_tx_isr::
	push R13
	push R4
	.dbline -1
	.dbline 319
; 
; 
; /***************************************************************************
; *    Funktion: Sendeinterrupt                                              *
; *    Autor:    Jens Altenburg                                              *
; ****************************************************************************/
; #pragma interrupt_handler uart0_tx_isr:UART0TX_VECTOR
; void uart0_tx_isr(void){
	.dbline 320
	mov.b _bTxState,R4
	and #255,R4
	cmp #0,R4
	jeq L50
	cmp #1,R4
	jeq L53
	cmp #2,R4
	jeq L54
	cmp #3,R4
	jeq L57
	jmp L47
X1:
	.dbline 320
;      switch(bTxState){
L50:
	.dbline 322
;           case enTxSync:
;                if(bSyncCount > 0){
	mov.b #0,R13
	cmp.b _bSyncCount,R13
	jhs L51
	.dbline 322
	.dbline 323
;                     U0TXBUF = nSync;
	mov.b #204,&0x77
	.dbline 324
;                     bSyncCount--;
	sub.b #1,_bSyncCount
	.dbline 325
;                     }
	jmp L48
L51:
	.dbline 326
;                else {
	.dbline 327
;                     U0TXBUF = nSyncEnd;     /* letztes Synczeichen senden */
	mov.b #240,&0x77
	.dbline 328
;                     bTxState = enTxSyncEnd;
	mov.b #1,_bTxState
	.dbline 329
;                     }
	.dbline 330
;                break;
	jmp L48
L53:
	.dbline 332
;           case enTxSyncEnd:
;                     U0TXBUF = *pTxBuffer;    /* erstes Zeichen senden */
	mov _pTxBuffer,R13
	mov.b @R13,&0x77
	.dbline 333
;                     pTxBuffer++;
	.dbline 334
;                     bTxIndex--;
	.dbline 335
;                     bTxState = enTxMessage;
	add #1,_pTxBuffer
	sub.b #1,_bTxIndex
	mov.b #2,_bTxState
	.dbline 336
;                break;
	jmp L48
L54:
	.dbline 338
;           case enTxMessage:
;                if(bTxIndex > 0){             /* und fleiig weiter */
	mov.b #0,R13
	cmp.b _bTxIndex,R13
	jhs L55
	.dbline 338
	.dbline 339
;                     U0TXBUF = *pTxBuffer;
	mov _pTxBuffer,R13
	mov.b @R13,&0x77
	.dbline 340
;                     pTxBuffer++;
	.dbline 341
;                     bTxIndex--;
	add #1,_pTxBuffer
	sub.b #1,_bTxIndex
	.dbline 342
;                     }
	jmp L48
L55:
	.dbline 343
;                else {
	.dbline 344
;                     U0TXBUF = nSync;         /* Dummy-Zeichen */
	mov.b #204,&0x77
	.dbline 345
;                     bTxState = enTxOff;
	mov.b #3,_bTxState
	.dbline 346
;                     }
	.dbline 347
;                break;
	jmp L48
L57:
	.dbline 349
;           case enTxOff:
;                     IE1 &= ~UTXIE0;          /* Tx-Interrupt sperren */
	and.b #-129,&0
	.dbline 350
;                     TXEN(0);
	and.b #251,&0x1d
	.dbline 351
;                     bRfState = enRfCheckCarrier;
	.dbline 352
;                     enState = enTxReady;     /* Sender wieder bereit */
	mov.b #1,_bRfState
	mov.b #0,_enState
	.dbline 353
;                break;
	jmp L48
L47:
	.dbline 355
	mov.b #3,_bTxState
	.dbline 356
L48:
	.dbline -2
	.dbline 358
;           default:
;                bTxState = enTxOff;
;                break;
;           }
;      }
L46:
	pop R4
	pop R13
	.dbline 0 ; func end
	reti
	.dbend
	.area vector(abs)
	.org 0xfff2
	.word _uart0_rx_isr
	.area text
	.dbfile C:\projekte\msp430\ct05\rf433.c
	.dbfunc e uart0_rx_isr _uart0_rx_isr fV
	.even
_uart0_rx_isr::
	push R10
	push R11
	push R12
	push R13
	push R14
	push R15
	.dbline -1
	.dbline 366
; 
; 
; /***************************************************************************
; *    Funktion: Empfangsinterrupt                                           *
; *    Autor:    Jens Altenburg                                              *
; ****************************************************************************/
; #pragma interrupt_handler uart0_rx_isr:UART0RX_VECTOR
; void uart0_rx_isr(void){
	.dbline 367
;      fRxFunc( U0RXBUF );
	mov.b &0x76,R14
	call _fRxFunc
	.dbline -2
	.dbline 368
;      }
L58:
	pop R15
	pop R14
	pop R13
	pop R12
	pop R11
	pop R10
	.dbline 0 ; func end
	reti
	.dbend
	.area bss
	.dbfile C:\projekte\msp430\ct05\rf433.c
_bTxState::
	.blkb 1
	.dbsym e bTxState _bTxState c
_bSyncCount::
	.blkb 1
	.dbsym e bSyncCount _bSyncCount c
_enState::
	.blkb 1
	.dbsym e enState _enState c
_bTxIndex::
	.blkb 1
	.dbsym e bTxIndex _bTxIndex c
	.even
_pTxBuffer::
	.blkb 2
	.dbsym e pTxBuffer _pTxBuffer pc
	.even
_fRxFunc::
	.blkb 2
	.dbsym e fRxFunc _fRxFunc pfV
_bTimeout::
	.blkb 1
	.dbsym e bTimeout _bTimeout c
_bRfState::
	.blkb 1
	.dbsym e bRfState _bRfState c
	.area lit
	.even
	.area idata
	.even
	.area data
	.even
	.area bss
	.even
