/***************************************************************************
* Titel        : TELE.C
*
* Description  : Telemtrie-Task
*
* Environment  : ICC430 V6.05, MSP430F149
*
* Responsible  : J. Altenburg
*
* Guidelines   :
*
* Revision List:
  --------------------------------------------------------------------------
  Date     | Author          | Change
  --------------------------------------------------------------------------
  12.02.04 |J. Altenburg     | first release
  --------------------------------------------------------------------------
           |                 |
  --------------------------------------------------------------------------
****************************************************************************/

/***************************************************************************
* HEADER-FILES (Only those that are needed in this file)                   *
****************************************************************************/
/* System-headerfiles */
#include "cdef.h"                  /* General definitions and types */
#include "msp430x14x.h"         /* MSP430 definitions */
#include "msp430def.h"

/* Own headerfiles */
#include "tele.h"

/* Foreign headerfiles */
#include "rf433.h"
#include "navi.h"

/***************************************************************************
* Defines und Makros
****************************************************************************/

/***************************************************************************
*    Local Function Prototypes
****************************************************************************/
typedef void (* fLocalFunc)( void );    /* function pointer */


/***************************************************************************
*    Global Variables
****************************************************************************/
#define nSim    16 
const NAVI_stJob stJobs[nSim] = {    enRobF, 15000, 400, /* 0 */
                                     enRobR, 35000, 125, /* R */
                                     enRobF, 15000, 400, /* 1 */
                                     enRobR, 35000, 125, /* R */
                                     enRobF, 15000, 800, /* 2 */
                                     enRobL, 35000, 125, /* L */
                                     enRobF, 15000, 400, /* 3 */
                                     enRobL, 35000, 125, /* L */
                                     enRobF, 15000, 400, /* 4 */
                                     enRobL, 35000, 125, /* L */
                                     enRobF, 15000, 800, /* 5 */
                                     enRobR, 35000, 125, /* R */
                                     enRobBl,20000, 1852,/* Bogen links */
                                     enRobBr,20000, 1852,/* Bogen rechts */
                                     enRobBl,20000, 1852,/* Bogen links */
                                     enRobBr,20000, 1852,/* Bogen rechts */
                                    }; /* Liste mit Testdaten */

/***************************************************************************
*    Code Area
****************************************************************************/
/***************************************************************************
*    Function:  TELE-Init
*
*    Author:    Jens Altenburg
****************************************************************************/
void TELE_vInit( void ){
    }

/***************************************************************************
*    Function:  TELE-Task
*    Author:    Jens Altenburg
****************************************************************************/
void TELE_vMain( void ){
    byte i = 0;
    while(1){
        if(True == NAVI_bNewJob((NAVI_stJob*) &stJobs[i])){ /* Jobliste fllen */
            P5OUT ^= 0x01;
            i++;
            if(i > nSim) i = 0;
            }
        }
    }


/***************************************************************************
* EOF: TELE.C
****************************************************************************/

