	.module uexec.c
	.area text
	.dbfile C:\projekte\msp430\ct05\uexec.c
	.dbfunc e vDummy _vDummy fV
;              a -> R4
	.even
_vDummy::
	push R4
	.dbline -1
	.dbline 49
; /***************************************************************************
; * Titel        : UEXC.C
; *
; * Description  : Multitasking Kernel Module 
; *
; * Environment  : ICC430 V6.05, MSP430F149
; *
; * Responsible  : Richrad F. Man
; *
; * Guidelines   :
; *
; * Revision List:
;   --------------------------------------------------------------------------
;   Date     | Author          | Change
;   --------------------------------------------------------------------------
;   12.02.04 |J. Altenburg     | fits to MSP430 
;   --------------------------------------------------------------------------
;            |                 |
;   --------------------------------------------------------------------------
; ****************************************************************************/
; /* System-headerfiles */
; #include <stdlib.h>
; 
; /* Own headerfiles */
; #include "uexec.h"
; 
; /***************************************************************************
; *    Global Variables
; ****************************************************************************/
; static TaskControlBlock free_list[NUM_TASKS], *free_list_ptr;
; TaskControlBlock *current_task;
; unsigned char *uexc_current_sp; 
; unsigned int  uexc_ticks;
;  
; void (*uexc_current_func)(void);
; 
; static int next_tid;
; static unsigned char null_task_stack[UEXC_MIN_STACK_SIZE];
; static void InitSystem(void);
; static void NullTask(void);
; static void KillTask(int tid);
; 
; 
; 
; /***************************************************************************
; * Function  : workaround because compiler bug
; * Author    : Jens Altenburg
; ****************************************************************************/
; void vDummy( void ){ 
	.dbline 51
; 	char a;          /* does nothing */
; 	a++;
	add.b #1,R4
	.dbline -2
	.dbline 52
; 	}
L2:
	pop R4
	.dbline 0 ; func end
	ret
	.dbsym r a 4 c
	.dbend
	.dbfunc e UEXC_StartScheduler _UEXC_StartScheduler fI
	.even
_UEXC_StartScheduler::
	.dbline -1
	.dbline 59
; 
; 
; /***************************************************************************
; * Function  : User functions
; * Author    : Richard F. Man
; ****************************************************************************/
; int UEXC_StartScheduler(void){  /* start the multitasking system */
	.dbline 60
;     uexc_ticks = 0;
	.dbline 61
;     if (current_task == 0) return -1;
	mov #0,_uexc_ticks
	cmp #0,_current_task
	jne L4
	.dbline 61
	mov #-1,R14
	jmp L3
L4:
	.dbline 62
;     UEXC_StartTimer();
	call #_UEXC_StartTimer
	.dbline 63
;     UEXC_Schedule();
	call #_UEXC_Schedule
	.dbline 64
;     return 0;                   /* never execute */
	mov #0,R14
	.dbline -2
L3:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e UEXC_CreateTask _UEXC_CreateTask fI
;           next -> R5
;              p -> R4
;          ticks -> 10(SP)
;     stack_size -> 8(SP)
;    stack_start -> R5
;           func -> R6
	.even
_UEXC_CreateTask::
	push R4
	push R5
	push R6
	mov R15,R5
	mov R14,R6
	.dbline -1
	.dbline 71
;     }
; 
; /* Create a new process and link it to the task list */
; int UEXC_CreateTask(void (*func)(void),
;                     unsigned char *stack_start,
;                     unsigned stack_size,
;                     unsigned ticks){
	.dbline 73
; 	TaskControlBlock *p, *next;
;     if (free_list_ptr == 0) InitSystem();
	cmp #0,_free_list_ptr
	jne L7
	.dbline 73
	call #_InitSystem
L7:
	.dbline 74
;     INTR_OFF();
	dint
	.dbline 75
;     p = free_list_ptr;
	.dbline 76
;     free_list_ptr = free_list_ptr->next;
	.dbline 77
;     p->func = func;
	mov _free_list_ptr,r13
	mov r13,R4
	mov @r13,_free_list_ptr
	mov R6,6(R4)
	.dbline 78
;     p->state = T_CREATED;
	mov.b #0,3(R4)
	.dbline 79
;     p->tid = next_tid++;
	mov _next_tid,r13
	add #1,_next_tid
	mov.b R13,2(R4)
	.dbline 80
;     p->ticks = (ticks == 0) ? DEFAULT_TICKS : ticks;
	cmp #0,10(R1)
	jne L10
	mov #5,R6
	jmp L11
L10:
	mov 10(R1),R6
L11:
	mov R6,R13
	mov.b R13,4(R4)
	.dbline 83
; 
;     /* stack grows from high address to low address */
;     p->stack_start = stack_start;
	mov R5,8(R4)
	.dbline 84
;     p->stack_end = stack_start+stack_size-1;
	mov 8(R1),R13
	add R5,R13
	mov R13,10(R4)
	add #-1,10(R4)
	.dbline 87
; 
;     /* align stack here, if needed */
; 	p->sp = (unsigned char *)((unsigned) p->stack_end /* & ~1*/);
	mov 10(R4),12(R4)
	.dbline 89
;     /* create a circular linked list */
;     if (current_task == 0) 
	cmp #0,_current_task
	jne L12
	.dbline 90
; 	    p->next = p, current_task = p;
	mov R4,0(R4)
	mov R4,_current_task
	jmp L13
L12:
	.dbline 92
;     else
;         next = current_task->next, current_task->next = p, p->next = next;
	mov _current_task,r13
	mov @r13,R5
	mov R4,0(r13)
	mov R5,0(R4)
L13:
	.dbline 93
;     INTR_ON();
	eint
	.dbline 94
;     return p->tid;
	mov.b 2(R4),R14
	and #255,R14
	.dbline -2
L6:
	pop R6
	pop R5
	pop R4
	.dbline 0 ; func end
	ret
	.dbsym r next 5 pX
	.dbsym r p 4 pX
	.dbsym l ticks 10 i
	.dbsym l stack_size 8 i
	.dbsym r stack_start 5 pc
	.dbsym r func 6 pfV
	.dbend
	.dbfunc e UEXC_Defer _UEXC_Defer fV
	.even
_UEXC_Defer::
	.dbline -1
	.dbline 98
;     }
; 
; /* Give up timeslice */
; void UEXC_Defer(void){
	.dbline 99
;     INTR_OFF();
	dint
	.dbline 100
;     uexc_current_sp = (unsigned char *)&current_task->sp;
	.dbline 101
;     UEXC_SavregsAndResched();
	mov _current_task,_uexc_current_sp
	add #12,_uexc_current_sp
	call #_UEXC_SavregsAndResched
	.dbline -2
	.dbline 102
;     }
L14:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e UEXC_HogProcessor _UEXC_HogProcessor fV
	.even
_UEXC_HogProcessor::
	.dbline -1
	.dbline 105
; 
; /* Hog the processor for more cycle time */
; void UEXC_HogProcessor(void){
	.dbline 106
;     INTR_OFF();
	dint
	.dbline 107
;     current_task->current_ticks = current_task->ticks;
	mov _current_task,r13
	mov.b 4(r13),5(r13)
	.dbline 108
;     INTR_ON();
	eint
	.dbline -2
	.dbline 109
;     }
L15:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e UEXC_KillTask _UEXC_KillTask fV
;              p -> R4
;             qb -> R5
;            tid -> R14
	.even
_UEXC_KillTask::
	push R4
	push R5
	.dbline -1
	.dbline 112
; 
; /* kill a process */
; void UEXC_KillTask(int tid) {
	.dbline 114
;     TaskControlBlock **qb, *p;
;     if (tid == 0) return; /* tid == 0 -> null task, never kill that */
	cmp #0,R14
	jne L17
	.dbline 114
	jmp L16
L17:
	.dbline 115
;     INTR_OFF();
	dint
	.dbline 118
;     /* search the circular list until we find a match or gone through
;      * the whole list */
;     for (qb = &(current_task)->next; (*qb)->tid != tid && *qb != current_task;
	mov _current_task,R5
	jmp L22
L19:
	.dbline 119
L20:
	.dbline 119
	mov @R5,R5
L22:
	.dbline 118
	mov @R5,r13
	mov.b 2(r13),R12
	and #255,R12
	cmp R14,R12
	jeq L23
	cmp _current_task,r13
	jne L19
L23:
	.dbline 121
;          qb = &(*qb)->next);
;     /* if found, then delete the process */
;     if ((*qb)->tid == tid){
	mov @R5,R13
	mov.b 2(R13),R13
	and #255,R13
	cmp R14,R13
	jne L24
	.dbline 121
	.dbline 127
;         /* If this is the head of the task list, reassign the
;          * head. This has the effect of skipping the next task
;          * for one round of scheduling but should not matter
;          * much.
;          */
;         if ((*qb) == current_task) current_task = current_task->next;
	mov @R5,R10
	cmp _current_task,R10
	jne L26
	.dbline 127
	mov _current_task,R13
	mov @R13,_current_task
L26:
	.dbline 129
;         /* delink and free the memory */
;         p = *qb;
	.dbline 130
;         *qb = (*qb)->next;
	mov @R5,R4
	mov @R5,R13
	mov @R13,0(R5)
	.dbline 131
;         p->next = free_list_ptr;
	mov _free_list_ptr,0(R4)
	.dbline 132
;         free_list_ptr = p;
	mov R4,_free_list_ptr
	.dbline 133
;         }
L24:
	.dbline 134
;     INTR_ON();
	eint
	.dbline -2
	.dbline 135
;     }
L16:
	pop R5
	pop R4
	.dbline 0 ; func end
	ret
	.dbsym r p 4 pX
	.dbsym r qb 5 ppX
	.dbsym r tid 14 I
	.dbend
	.dbfunc s InitSystem _InitSystem fV
;              i -> R4
	.even
_InitSystem:
	push R4
	sub #4,R1
	.dbline -1
	.dbline 142
; 
; 
; /***************************************************************************
; * Function  : Internal functions
; * Author    : Richard F. Man
; ****************************************************************************/
; static void InitSystem(void){ /* Initialize the system */
	.dbline 145
;     int i;
;     /* initialize the free list */
;     for (i = 0; i < NUM_TASKS-1; i++)
	mov #0,R4
L29:
	.dbline 146
	push SR
	dint
	nop
	mov #14,&0x130
	mov R4,&0x138
	mov &0x13A,r13
	pop SR
	mov #_free_list+14,R12
	mov r13,R11
	add R12,R11
	mov #_free_list,R12
	add R12,R13
	mov R11,0(R13)
L30:
	.dbline 145
	add #1,R4
	.dbline 145
	cmp #3,R4
	jl L29
	.dbline 147
;         free_list[i].next = &free_list[i+1];
;     free_list_ptr = &free_list[0];
	.dbline 149
;     /* null task has tid of 0 */
;     UEXC_CreateTask(NullTask, null_task_stack, sizeof (null_task_stack), 0);
	mov #_free_list,R13
	mov R13,_free_list_ptr
	mov #0,2(R1)
	mov #100,0(R1)
	mov #_null_task_stack,R15
	mov #_NullTask,R14
	call #_UEXC_CreateTask
	.dbline -2
	.dbline 150
;     }
L28:
	add #4,R1
	pop R4
	.dbline 0 ; func end
	ret
	.dbsym r i 4 I
	.dbend
	.dbfunc e UEXC_KillSelf _UEXC_KillSelf fV
	.even
_UEXC_KillSelf::
	.dbline -1
	.dbline 153
; 
; /* This is the "return point" of a new task. Reclaim storage and reschdule */
; void UEXC_KillSelf(void){
	.dbline 154
;     UEXC_KillTask(current_task->tid);
	mov _current_task,R13
	mov.b 2(R13),R14
	and #255,R14
	call #_UEXC_KillTask
	.dbline 155
;     UEXC_Schedule();
	call #_UEXC_Schedule
	.dbline -2
	.dbline 156
;     }
L34:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc s NullTask _NullTask fV
	.even
_NullTask:
	.dbline -1
	.dbline 159
; 
; /* Always runnable task. This has the tid of zero */
; static void NullTask(void)    {
	jmp L37
L36:
	.dbline 160
	.dbline 161
	call #_UEXC_Defer
	.dbline 162
L37:
	.dbline 160
	jmp L36
X0:
	.dbline -2
	.dbline 163
;     while (1){
;         UEXC_Defer();
; 		}
;     }
L35:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e UEXC_CheckTask _UEXC_CheckTask fV
	.even
_UEXC_CheckTask::
	.dbline -1
	.dbline 166
; 
; /* called by the timer interrupt. See if we need to reschedule */
; void UEXC_CheckTask(void){
	.dbline 167
;     uexc_ticks++;
	.dbline 168
;     if (uexc_current_sp > current_task->stack_end ||
	add #1,_uexc_ticks
	mov _uexc_current_sp,r13
	mov _current_task,r12
	cmp r13,10(r12)
	jlo L42
	cmp 8(r12),r13
	jhs L40
L42:
	.dbline 170
;         uexc_current_sp < current_task->stack_start)
;         UEXC_KillSelf();
	call #_UEXC_KillSelf
L40:
	.dbline 172
	mov _current_task,R13
	add #5,r13
	mov.b @r13,R12
	and #255,R12
	sub #1,R12
	mov.b r12,0(r13)
	cmp.b #0,r12
	jne L43
	.dbline 172
	.dbline 173
	mov _current_task,R13
	mov _uexc_current_sp,12(R13)
	.dbline 174
	call #_UEXC_Schedule
	.dbline 175
L43:
	.dbline -2
	.dbline 176
;     /* decrement the tick value and reschedule if needed */
;     if (--current_task->current_ticks == 0){
;         current_task->sp = uexc_current_sp; /* memorize the state */
;         UEXC_Schedule();
;         }
;     }
L39:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e UEXC_Schedule _UEXC_Schedule fV
	.even
_UEXC_Schedule::
	.dbline -1
	.dbline 182
; 
; /* Run a different task. Set the current task as the next one in the (circular)
;  * list, then set the global variables and call the appropriate asm routines
;  * to do the job.
;  */
; void UEXC_Schedule(void){
	.dbline 183
;     current_task = current_task->next;  /* pick the next task in the list */
	.dbline 184
;     vDummy();                           /* workaround */
	mov _current_task,R13
	mov @R13,_current_task
	call #_vDummy
	.dbline 185
; 	current_task->current_ticks = current_task->ticks;
	mov _current_task,r13
	mov.b 4(r13),5(r13)
	.dbline 186
; 	uexc_current_sp = current_task->sp; /* set the global variables and go */
	.dbline 187
; 	if (current_task->state == T_READY)
	mov 12(r13),_uexc_current_sp
	cmp.b #1,3(r13)
	jne L46
	.dbline 188
;         UEXC_Resume();
	call #_UEXC_Resume
	jmp L47
L46:
	.dbline 190
	.dbline 191
	mov _current_task,R13
	mov.b #1,3(R13)
	.dbline 192
	.dbline 193
	mov 6(R13),_uexc_current_func
	call #_UEXC_StartNewTask
	.dbline 194
L47:
	.dbline -2
	.dbline 195
;     else /* if (task->state == T_CREATED) */
;         {
;         current_task->state = T_READY;
;         uexc_current_func = current_task->func;
;         UEXC_StartNewTask();
;         }
;     }
L45:
	.dbline 0 ; func end
	ret
	.dbend
	.area bss
	.dbfile C:\projekte\msp430\ct05\uexec.c
_null_task_stack:
	.blkb 100
	.dbsym s null_task_stack _null_task_stack A[100:100]c
	.even
_next_tid:
	.blkb 2
	.dbsym s next_tid _next_tid I
	.even
_uexc_ticks::
	.blkb 2
	.dbsym e uexc_ticks _uexc_ticks i
	.even
_current_task::
	.blkb 2
	.dbsym e current_task _current_task pX
	.even
_free_list_ptr:
	.blkb 2
	.dbsym s free_list_ptr _free_list_ptr pX
	.even
_free_list:
	.blkb 56
	.dbsym s free_list _free_list A[56:4]X
	.even
_uexc_current_func::
	.blkb 2
	.dbsym e uexc_current_func _uexc_current_func pfV
	.even
_uexc_current_sp::
	.blkb 2
	.dbsym e uexc_current_sp _uexc_current_sp pc
	.area lit
	.even
	.area idata
	.even
	.area data
	.even
	.area bss
	.even
